require "defines"
require "config"
game.on_event(defines.events.on_chunk_generated,
              function(event)
                 if (event.surface.name == "nauvis" and
                     (math.abs(event.area.left_top.x) <= canal_width/2 or
                      math.abs(event.area.right_bottom.x) <= canal_width/2)) then
                    tiles = {}
                    for x=event.area.left_top.x, event.area.right_bottom.x do
                       if math.abs(x) <= canal_width/2 then
                          for y=event.area.left_top.y, event.area.right_bottom.y do
                             if math.abs(y) >= bridge_width/2 then
                                if string.find(event.surface.get_tile(x, y).name, "water") == nil then
                                   table.insert(tiles, {name = "water", position = {x, y}})
                                end
                             else
                                if string.find(event.surface.get_tile(x, y).name, "water") ~= nil then
                                   table.insert(tiles, {name = "grass", position = {x, y}})
                                end
                             end
                          end
                       end
                    end
                    event.surface.set_tiles(tiles)
                 end
              end)
